// prj_demo.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"

#include "agora_api_win.h"
#include <iostream>
#include <vector>

#define TEST_MEDIA 0

#if TEST_MEDIA==1
#include "AgoraAudioSDK.h"

    class _IAgoraAudioEventHandler : public IAgoraAudioEventHandler 
    {
        void *m_this ;
    public:
        _IAgoraAudioEventHandler(void *x) : m_this(x){}
        virtual void onJoinSuccess(const char* channel, uid_t uid, int elapsed) override  {
			std::cout << "join ------------ media ------------ success " << std::endl;
        }
    };

IAgoraAudio* m_media = NULL;
_IAgoraAudioEventHandler *m_IAgoraAudioEventHandler = NULL;

#endif
 
using namespace agora_sdk_win;
using namespace std;

IAgoraAPI *agoraInst ;
 
typedef struct{
    string name;
    uint32_t uid;
}User;

vector<User> peers;

string g_vendor = "";
string g_username = "";
string g_token = "";  
uint32_t g_uid = 0;
string g_channel = "";

int g_call_n = 0;

bool g_queried = false;
bool g_reconnect = false;
string dbg_ip = 
	//"123.125.184.7"
	//"122.227.254.8"
	"";
 
static void do_login(){
    cout << "Login as " << g_username << " ..." << endl;
	agoraInst->login(
		g_vendor.data(),
		g_vendor.size(),
		g_username.data(),
		g_username.size(),
		g_token.data(),
		g_token.size(),
		g_uid, 
		"",
		0);
}

class CallBack : public ICallBack{
    virtual void onLoginSuccess(uint32_t uid, int fd) override {
        cout << "onLoginSuccess" << endl;
   
        if (g_channel != ""){
            cout << "Ready to start call : " << endl;
            cout << "Join channel : " << g_channel << " ..." << endl;
            agoraInst->channelJoin(g_channel.data(), g_channel.size());
#if TEST_MEDIA==1
			m_media->joinChannel(g_vendor.c_str(), g_channel.c_str(), "1", uid);
#endif
        }


        if (g_queried){
            if (g_reconnect) agoraInst->logout();  
        }else{
            agoraInst->channelQueryUserNum(g_channel.data(), g_channel.size());
        }


        // agoraInst->messageAppSend("{\"message\":{\"id\":3,\"timestamp\":1435635235511,\"data\":{\"uids\":[7914]},\"type\":3,\"cmd\":\"getProfiles\"}}", "000");
        // agoraInst->messagePushSend(g_username, g_uid, "hello yy", "000");
    }   

    virtual void onMessageAppReceived(char const * msg, size_t msg_size)  override{
        cout << "onMessageAppReceived " << msg << endl;
    }

    virtual void onChannelQueryUserNumResult(char const * channelID, size_t channelID_size,int ecode,int num)  override {
        cout << "onChannelQueryUserNumResult " << channelID << " " << ecode << " " << num << endl;

        if (ecode==0){
            g_queried = true;    
			if (g_reconnect) agoraInst->logout(); 
        }
        
    }

    virtual void onLoginFailed(int ecode)  override{
        cout << "onLoginFailed : ecode = " << ecode << endl;

        //do_login();     
		exit(-1);
    }

    virtual void onLogout(int ecode)  override{
        cout << "onLogout : ecode = " << ecode << endl;

        do_login();
    }

	bool call_next(){
		if (g_call_n<peers.size()){
			User &u = peers[g_call_n++];
            if (u.uid == 1){
                cout << "Invite phone : " << u.name << " to channel ..." << endl;
                agoraInst->channelInvitePhone(g_channel.data(), g_channel.size(), u.name.data(), u.name.size());
            }else{
                cout << "Invite user : " << u.name << "(" << u.uid << ") to channel ..." << endl;
                agoraInst->channelInviteUser(g_channel.data(), g_channel.size(), 
										 u.name.data(), u.name.size(),
										 u.uid);
            }
			return true;
		}
		return false;
	}
 
    virtual void onChannelJoined(char const * channelID, size_t channelID_size)  override{
        cout << "Join channel successfully." << endl;

        // send channel msg
		if (1){
			string msg = string("hello everyone I'm ") + g_username;
			cout << "send channel msg :" << msg << endl;
			string msgID = "join_message";
			agoraInst->messageChannelSend(
				channelID, channelID_size, 
				msg.data(), msg.size(), 
				msgID.data(), msgID.size()
				);
		}

        // send invite
		while(call_next());

		/*
		for(list<User>::iterator it = peers.begin(); it!=peers.end(); it++){
			User &u = *it;
            if (u.uid == 1){
                cout << "Invite phone : " << u.name << " to channel ..." << endl;
                agoraInst->channelInvitePhone(g_channel, u.name);
            }else{
                cout << "Invite user : " << u.name << "(" << u.uid << ") to channel ..." << endl;
                agoraInst->channelInviteUser(g_channel, u.name, u.uid);
            }
        }
		*/

//    	agoraInst->channelInviteUser("room1", "aa");
    }

    virtual void onChannelUserJoined(char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Event : " << account << ":" << uid << " joined" << endl;


        // send Instant msg
        if (account != g_username){
            string msg ;
            msg += "Hi " + string(account,account_size) + ", I'm " + g_username;
			string msgID = "first_Instant_msg";
            agoraInst->messageInstantSend(
				account, account_size, 
				uid, 
				msg.data(), msg.size(), 
				msgID.data(), msgID.size());

			//agoraInst->channelLeave(g_channel.data(), g_channel.size());
        }
    }
    virtual void onChannelUserLeaved(char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Event : " << account << ":" << uid << " leaved" <<  endl;
    }
	virtual void onChannelLeaved(char const * channelID, size_t channelID_size, int e_code)  override{
        cout << "onChannelLeaved : " << g_username <<  endl;
    }

    virtual void onChannelUserList(int n, char **accounts, uint32_t* uids)  override{
        cout << "Channel User list : " <<  endl;
        for(int i=0;i<n;i++){
            cout << accounts[i] << ":" << uids[i] <<  endl;
        }

		
		//agoraInst->channelLeave(g_channel.data(), g_channel.size());

    }

    virtual void onInviteReceived(char const * channelID, size_t channelID_size,char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Received invitation from " << account << " join channel : " << channelID << endl;

        cout << "Joining " << channelID << endl;
        agoraInst->channelJoin(channelID, channelID_size);

        cout << "Accept invitaction from " << account << endl;
        agoraInst->channelInviteAccept(
			channelID, channelID_size, 
			account, account_size, 
			uid);
    }

    virtual void onInviteReceivedByPeer(char const * channelID, size_t channelID_size,char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Invitation received by " << account << "" << endl;
    }

    virtual void onInviteAcceptedByPeer(char const * channelID, size_t channelID_size,char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Invitation acceptd by " << account << endl;

		call_next();
    }

    virtual void onInviteRefusedByPeer(char const * channelID, size_t channelID_size,char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Invitation refused by " << account << endl;
    }

    virtual void onInviteEndByPeer(char const * channelID, size_t channelID_size,char const * account, size_t account_size,uint32_t uid)  override{
        cout << "Invitation end by " << account << endl;
    }

    virtual void onLog(char const * txt, size_t txt_size)  override{
    	//cout << "LOG:" << txt << endl;
    }

    virtual void onMessageInstantReceive(char const * account, size_t account_size,uint32_t uid,char const * msg, size_t msg_size)  override{
        cout << "onMessageInstantReceive from " << account << ":" << uid << " " << msg << endl;
    }
    virtual void onMessageChannelReceive(char const * channelID, size_t channelID_size,char const * account, size_t account_size,uint32_t uid,char const * msg, size_t msg_size)  override{
        cout << "onMessageChannelReceive " << channelID << " from " << account << ":" << uid << " " << msg << endl;
    }
};

uint32_t my_atol(char *n){
	uint32_t x=0;
	while(*n){
		x = x*10 + (*n)-'0';
		n++;
	}
	return x;
}

agora::rtc::IRtcEngine* g_media;
agora::rtc::RtcEngineContext g_media_context;

int main(int argc, char** argv){


    if (argc<5){
        printf(" Usage : demo [vendorKey] [userName] [uid] [token] \n");
        printf("         demo [vendorKey] [userName] [uid] [token] [channelName] [peerName] [peerUid] ... \n");
        printf("\n");
		exit(-1);
    }
    g_vendor = argv[1];
    g_username = argv[2];
    g_uid = my_atol(argv[3]);
    g_token = argv[4];

    if (argc>5){
        g_channel = argv[5];

        for(int i=6;i<argc;i+=2){
            User user;
            user.name = argv[i];
            user.uid = my_atol(argv[i+1]);
            peers.push_back(user);
        }
    }



	g_media = createAgoraRtcEngine();
	g_media_context.vendorKey = g_vendor.c_str();
	g_media_context.eventHandler = NULL;
	g_media->initialize(g_media_context);

	agoraInst = getAgoraSDKInstanceWinWithMedia(g_media);

	agoraInst->callbackSet(new CallBack());
	ICallBack *cb = agoraInst->callbackGet();

#if TEST_MEDIA==1
	m_IAgoraAudioEventHandler = new _IAgoraAudioEventHandler(NULL);
	m_media = createAgoraAudioInstance(m_IAgoraAudioEventHandler);
#endif

	auto media = agoraInst->getMedia();



	if (dbg_ip!=""){
		agoraInst->dbg("dbgip", strlen("dbgip"), dbg_ip.c_str(), dbg_ip.size());
	}

    do_login();
	agoraInst->start();
    cout << "Bye" << endl;
}

