//
//  ViewController.m
//  iosapp1
//
//  Created by vv on 18/6/15.
//  Copyright (c) 2015 Agora. All rights reserved.
//

#import "ViewController.h"

#import "agorasdk.h"
#import "AgoraRtcEngineKit.h"

#import "demohelp.h"

#import <CommonCrypto/CommonDigest.h>

#define vendorKey @""
#define signkey @""
#define enableMediaCertificate 0

@interface ViewController ()
@property (weak, nonatomic) IBOutlet UISegmentedControl *userSelection;

//@property (weak, nonatomic) IBOutlet UIButton *joinButton;
//@property (weak, nonatomic) IBOutlet UILabel *VendorID;
@property (weak, nonatomic) IBOutlet UITextView *logText;
@property (weak, nonatomic) IBOutlet UIButton *btnCallUser;
@property (weak, nonatomic) IBOutlet UIButton *btnLogin;
@property (weak, nonatomic) IBOutlet UIButton *btnJoin;

//@property (weak, nonatomic) IBOutlet UITextField *txtPhone;
@property (weak, nonatomic) IBOutlet UITextField *txtChannel;

@property (weak, nonatomic) IBOutlet UITextField *txtAccount1;

@property (weak, nonatomic) IBOutlet UITextField *txtAccount2;

@property (weak, nonatomic) IBOutlet UIButton *btnCallPhone;

@property (weak, nonatomic) IBOutlet UIButton *btnSwitch;

@property (weak, nonatomic) IBOutlet UIButton *btnMsg;


@end

@implementation ViewController{
    NSMutableString * logString;
//    NSString *call_channel;
    BOOL isLogin;
    BOOL isJoined;
    BOOL isInCall;
    int msg_count;
    unsigned my_uid;
    
    AgoraAPI* inst;
    AgoraRtcEngineKit * instMedia;
}

- (NSString*)MD5:(NSString*)s
{
    // Create pointer to the string as UTF8
    const char *ptr = [s UTF8String];
    
    // Create byte array of unsigned chars
    unsigned char md5Buffer[CC_MD5_DIGEST_LENGTH];
    
    // Create 16 byte MD5 hash value, store in buffer
    CC_MD5(ptr, strlen(ptr), md5Buffer);
    
    // Convert MD5 value in the buffer to NSString of hex values
    NSMutableString *output = [NSMutableString stringWithCapacity:CC_MD5_DIGEST_LENGTH * 2];
    for(int i = 0; i < CC_MD5_DIGEST_LENGTH; i++)
        [output appendFormat:@"%02x",md5Buffer[i]];
    
    return output;
}

- (NSString *) calcToken:(NSString *)_vendorKey signKey:(NSString *)signKey account:(NSString*)account expiredTime:(unsigned)expiredTime {
    // Token = 1:vendorKey:expiredTime:sign
    // Token = 1:vendorKey:expiredTime:md5(account + vendorID + signKey + expiredTime)
    
    NSString * sign = [self MD5:[NSString stringWithFormat:@"%@%@%@%d", account, _vendorKey, signKey, expiredTime]];
    return [NSString stringWithFormat:@"1:%@:%d:%@", _vendorKey, expiredTime, sign];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    isLogin = false;
    isJoined = false;
    msg_count = 1;
    isInCall = false;
    
    inst =  [AgoraAPI getInstanceWithoutMedia:vendorKey];
    instMedia = [AgoraRtcEngineKit sharedEngineWithVendorKey:vendorKey delegate:nil];
    
    [instMedia setParameters:@"{\"rtc.log_filter\":32783}"];
    
    inst.onLoginSuccess = ^(uint32_t uid, int fd){
        my_uid = uid;
        [self log:[NSString stringWithFormat:
                   @"Login successfully "
                   ]];
//        [inst joinChannel:@"channelName1"];
    };
    
    inst.onLogout = ^(AgoraEcode e){
        if (e == AgoraEcode_LOGOUT_E_USER){
            [self log:[NSString stringWithFormat:
                       @"Logout successfully "
                       ]];
        }else{
            [self log:[NSString stringWithFormat:
                       @"Logout on %d",
                       e
                       ]];
        }
        
        [self set_state_logout];
        [self set_state_not_in_call];
        if (isJoined) [self doLeave];
    };
    
    inst.onLoginFailed = ^(AgoraEcode e){
        [self log:[NSString stringWithFormat:
                   @"Login failed %d ", e
                   ]];
        [self set_state_logout];
        [self set_state_not_in_call];
    };
    
    inst.onChannelJoined = ^(NSString* name){
        [self log:[NSString stringWithFormat:
                   @"Join channel %@ successfully", name
                   ]];
    };
    
    inst.onChannelLeaved = ^(NSString* name, AgoraEcode ecode){
        if (ecode == AgoraEcode_LEAVECHANNEL_E_BYUSER){
            [self log:[NSString stringWithFormat:
                       @"Leave channel %@ successfully", name
                       ]];
        }else{
            [self log:[NSString stringWithFormat:
                       @"Leave channel %@ on %d ",  name, ecode
                       ]];
        }
    };
    
    inst.onInviteReceived = ^(NSString* channel, NSString *name, uint32_t uid){
        self.txtChannel.text = channel;
        
        [self log:[NSString stringWithFormat:
                    @"onInviteReceived to %@ from %@:%u", channel, name, uid
                    ]];
        
        [self log:[NSString stringWithFormat:
                   @"channelInviteAccept %@ from %@:%u", channel, name, uid
                   ]];
        
        [self set_state_in_call];
        [self doJoin];
        [inst channelInviteAccept:channel account:name uid:uid];
    };
    
    inst.onInviteReceivedByPeer = ^(NSString* channel, NSString *name, uint32_t uid){
        [self log:[NSString stringWithFormat:
                   @"onInviteReceivedByPeer to %@ from %@:%u", channel, name, uid
                   ]];
    };
    
    inst.onInviteAcceptedByPeer = ^(NSString* channel, NSString *name, uint32_t uid){
        [self log:[NSString stringWithFormat:
                   @"onInviteAcceptedByPeer to %@ from %@:%u", channel, name, uid
                   ]];
    };
    
    inst.onInviteEndByPeer = ^(NSString* channel, NSString *name, uint32_t uid){
        [self log:[NSString stringWithFormat:
                   @"onInviteEndByPeer to %@ from %@:%u", channel, name, uid
                   ]];
        
        
        [self set_state_not_in_call];
        [self doLeave];
    };
    
    inst.onInviteEndByMyself = ^(NSString* channel, NSString *name, uint32_t uid){
        [self log:[NSString stringWithFormat:
                   @"onInviteEndByMyself to %@ from %@:%u", channel, name, uid
                   ]];
    };
    
    inst.onInviteFailed = ^(NSString* channelID,NSString* account,uint32_t uid,AgoraEcode ecode){
        
        [self log:[NSString stringWithFormat:
                   @"Call %@ failed, ecode = %d", account, ecode
                   ]];
        
        
        [self set_state_not_in_call];
        [self doLeave];
    };
    
    inst.onChannelUserLeaved = ^(NSString *name, uint32_t uid){
        [self log:[NSString stringWithFormat:
                   @"onChannelUserLeaved %@:%u", name, uid
                   ]];
    };
    
    inst.onMessageChannelReceive = ^(NSString* channelID,NSString* account,uint32_t uid,NSString* msg) {
        [self log:[NSString stringWithFormat:
                   @"Recv channel msg from %@:%u: %@ ", account, uid, msg
                   ]];
    };
    
    
    inst.onMessageInstantReceive = ^(NSString* account,uint32_t uid,NSString* msg) {
        [self log:[NSString stringWithFormat:
                   @"Recv inst msg from %@:%u: %@ ", account, uid,  msg
                   ]];
    };

    
    inst.onLog = ^(NSString *txt){
        NSLog(@"%@", txt);

        if ([txt rangeOfString:@"onError"].location != NSNotFound){
            return;
        }
            
    };
    
    
    //    [inst dbg:@"lbss" b:@"125.88.159.176"];

}

- (IBAction)onLogin:(id)sender {
    
    if (isLogin){
        [self set_state_logout];
        
        // logout
        [self log:[NSString stringWithFormat:
                   @"Logout"
                   ]];
        
        [inst logout];
        
    }else{
        [self set_state_login];
        
        NSString *name = self.txtAccount1.text;
        uint32_t uid = 0;
        
        [self log:[NSString stringWithFormat:
                   @"Login as %@", name
                   ]];
        
        unsigned expiredTime =  (unsigned)[[NSDate date] timeIntervalSince1970] + 3600;

        [inst login2:vendorKey
            account:name
              token:[self calcToken:vendorKey signKey:signkey account:name expiredTime:expiredTime]
                uid:uid
           deviceID:@""
    retry_time_in_s:60
        retry_count:5
         
         ];

    }
}



- (IBAction)onSpeakerChange:(id)sender {
    UISwitch *switchButton = (UISwitch*)sender;
    [instMedia setEnableSpeakerphone:[switchButton isOn]];
};


- (IBAction)onBtnSwitch:(id)sender {
    NSString *name = self.txtAccount1.text;
    self.txtAccount1.text = self.txtAccount2.text;
    self.txtAccount2.text = name;
};


- (IBAction)onBtnMsg:(id)sender {
    if (isJoined){
  
        NSString * channelName = self.txtChannel.text;
        
        NSString * msg = [NSString stringWithFormat:
        @"msg %d from %@", msg_count++, self.txtAccount1.text
                          ];
        [inst messageChannelSend:channelName msg:msg msgID:@""];
    }
};



- (IBAction)onBtnInstMsg:(id)sender {
    
        NSString *name = self.txtAccount2.text;
        NSString * msg = [NSString stringWithFormat:
                          @"msg %d from %@", msg_count++, self.txtAccount1.text
                          ];
        [inst messageInstantSend:name uid:0 msg:msg msgID:@""];
    
};

- (IBAction)onBtnJoin:(id)sender {
    
    if (!isLogin) return;

    if (isJoined){
        [self doLeave];
    }else{
        [self doJoin];
    }

}

- (IBAction)onBtnCall:(id)sender {
    
    if (!isLogin) return;

    
    NSString *name = self.txtAccount2.text;
    uint32_t uid = 0;
    
    NSString * channelName = self.txtChannel.text;
    
    if (isInCall){
        [self log:[NSString stringWithFormat:
                   @"End call %@ to %@", name, channelName
                   ]];
        
        [self set_state_not_in_call];
        [self doLeave];
        [inst channelInviteEnd:channelName account:name uid:uid];
        
        
    }else{
        [self log:[NSString stringWithFormat:
                   @"Invite %@:%u to %@", name, uid, channelName
                   ]];
        
        [self set_state_in_call];
        [self doJoin];
        [inst channelInviteUser:channelName account:name uid:uid];

    }
}

- (void) doJoin
{
    dispatch_async(dispatch_get_main_queue(), ^(){
        isJoined = true;
        [self.btnJoin setTitle:@"Leave" forState:UIControlStateNormal];
    
        [self log:[NSString stringWithFormat:
               @"Join channel %@", self.txtChannel.text
               ]];
    
        [inst channelJoin:self.txtChannel.text];
        
        NSString *key = vendorKey;
        
        if (enableMediaCertificate){
         
            key = [KeyHelp createMediaKeyByAppID:vendorKey
                                  appCertificate:signkey
                                     channelName:self.txtChannel.text
                                          unixTs:time(NULL)
                                       randomInt:(rand()%256 << 24) + (rand()%256 << 16) + (rand()%256 << 8) + (rand()%256)
                                             uid:my_uid
                                       expiredTs:0
                   ];
            
//            [self log: [NSString stringWithFormat:
//                        @"key %@", key
//                        ]];
        }
        
        [instMedia joinChannelByKey:key channelName:self.txtChannel.text info:nil uid:my_uid joinSuccess:nil];
    });
}

- (void) doLeave
{
    dispatch_async(dispatch_get_main_queue(), ^(){
        isJoined = false;
        [self.btnJoin setTitle:@"Join" forState:UIControlStateNormal];
        [self log:[NSString stringWithFormat:
                   @"Leave channel %@", self.txtChannel.text
                   ]];
        
        [inst channelLeave:self.txtChannel.text];
        [instMedia leaveChannel:nil];
    });
}


- (void)set_state_logout{
    isLogin = false;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnLogin setTitle:@"Login" forState:UIControlStateNormal];
    });
}

- (void)set_state_login{
    isLogin = true;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnLogin setTitle:@"Logout" forState:UIControlStateNormal];
    });
}



- (void)set_state_in_call{
    isInCall = true;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnCallUser setTitle:@"Bye" forState:UIControlStateNormal];
    });
}

- (void)set_state_not_in_call{
    isInCall = false;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnCallUser setTitle:@"Call" forState:UIControlStateNormal];
    });
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void) log : (NSString *)txt{
    [self performSelectorOnMainThread:@selector(appendLogString:) withObject:txt waitUntilDone:YES];
//    [self performSelectorOnMainThread:@selector(appendLogString:) withObject:txt];
//    [self appendLogString:txt];
    NSLog(@"%@", txt);
}

- (NSMutableString *)logString
{
    if (!logString) {
        logString = [[NSMutableString alloc] init];
    }
    return logString;
}

- (void)appendLogString:(NSString *)tt
{
    [self.logString appendFormat:@"%@\n", tt];
    
    self.logText.text = self.logString;
    [self.logText scrollRangeToVisible:NSMakeRange(self.logString.length, 0)];
}

@end
